
/* Generated by TL2Java Version 1.1, February 9, 2001 */
import org.w3c.dom.*;
import java.io.*;
import java.util.*;

/**
 * Program Generator created by TL2Java
 * @version Mon Apr 09 16:45:30 EDT 2001
 */
public class TL2Java {
    Properties properties = new Properties();

     public String version = "TL2Java Version 1.2, April 9, 2001";

/* Copyright (c) 2001, Craig Cleaveland,  All rights reserved.
	http://craigc.com

Redistribution and use in source and binary forms, with or
without modification, are permitted provided that the following
conditions are met:

  Redistributions of source code must retain the above
  copyright notice, this list of conditions and the following
  disclaimer.

  Redistributions in binary form must reproduce the above copyright
  notice, this list of conditions and the following disclaimer in the
  documentation and/or other materials provided with the distribution.

  Neither Craig Cleaveland nor the names of its contributors may be
  used to endorse or promote products derived from this software
  without specific prior written permission. 

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

*/


    String ind = "    ";
    int uid = 0;

    /**
     * This method generates code for the different TL constructs
     * @author Craig Cleaveland
     */
    public boolean generate2(XPathContext context, ProgramWriter out) {
        out.setIndent(out.getIndent()+ind);
        out.print(ind);
        try {
            NodeList x = context.evalNodeSet("*|text()");
            for (int j=0; j<x.getLength(); ++j) {
                Node n = (Node) x.item(j);
                boolean strip = true;
                if (j<x.getLength()-1) {
                    Node n2 = (Node) x.item(j+1);
                    int t2 = n2.getNodeType();
                    if (t2==Node.TEXT_NODE) {
                        strip = false;
                    } else if (t2==Node.ELEMENT_NODE) {
                        String ename = n2.getNodeName();
                        if (ename.equals("value") || ename.equals("expr") || ename.equals("empty")) {
                            strip = false;
                        }
                        context.push(n2, 1, 1);
                        String reverse = context.evalString("@whitespace");
                        if (reverse.equals("reverse")) {
                            strip = !strip;
                        }
                    }
                }
                context.push(n, j+1, x.getLength());
                switch (n.getNodeType()) {
                case Node.ELEMENT_NODE:
                    String ename = n.getNodeName();
                    if (ename.equals("value")) {
                        out.println("out.print(context.evalString(\""
                            +context.evalString("@path")+"\"));");
                    } else if (ename.equals("for")) {
                        ++uid;
                        String var = context.evalString("@var");
                        if (var.equals("")) {
                            var = "loopvar"+uid;
                        }
                        out.println("NodeList x"+uid+" = context.evalNodeSet(\""
                            +context.evalString("@path")+"\");");
                        out.println("for (int j"+uid+"=0; j"+uid+"<x"+uid
                            +".getLength(); ++j"+uid+") {");
                        out.println(ind+"Node "+var+" = (Node) x"+uid
                            +".item(j"+uid+");");
                        out.println(ind+"context.push("+var+", j"+uid
                            +"+1, x"+uid+".getLength());");
                        out.println(ind+"context.setVariable(\""+var+"\", "+var+");");
                        generate2(context, out);
                        out.println("context.pop();");
                        out.println("}");
                    } else if (ename.equals("if")) {
                        out.println("if (context.evalBoolean("
                            +quoteString(context.evalString("@path"))+")) {");
                        generate2(context, out);
                        out.println("\n}");
                    } else if (ename.equals("else")) {
                        out.setIndent(out.getIndent()+ind);
                        out.println("} else {");
                        generate2(context, out);
                        out.setIndent(out.getIndent().substring(ind.length()));
                    } else if (ename.equals("expr")) {
                        out.println("out.print("+
                            context.evalString(".")+");");
                    } else if (ename.equals("java")) {
                        out.println(context.evalString("."));
                    } else if (ename.equals("empty")) {
                    } else if (ename.equals("declare")) {
                    } else if (ename.equals("declarations")) {
                    } else {
                        out.println("//Unknown Element: "+n.getNodeName());
                    }
                    break;
                case Node.TEXT_NODE:
                    String t = context.evalString(".");
                    if (strip) {
                        t = strip(t);
                    }
                    if (!t.equals("")) {
                        out.println("out.print("+quoteString(t)+");");
                    }
                    break;
                }
                context.pop();
            }
        } catch (Exception e) {
            System.out.println("Exception in generate2: "+e.getMessage());
            e.printStackTrace();
            return false;
        } finally {
            out.setIndent(out.getIndent().substring(ind.length()));
        }
        return true;
    }
    
    /** Add quotes and convert new lines, tabs  quotes */
    public String quoteString(String t) {
        String r = "";
        for (int j=0; j<t.length(); ++j) {
            char c = t.charAt(j);
            if (c=='\n') {
                r += "\\n";
            } else if (c=='"') {
                r += "\\\"";
            } else if (c=='\t') {
                r += "\\t";
            } else if (c=='\\') {
                r += "\\\\";
            } else {
                r += c;
            }
        }
        return "\""+r+"\"";
    }
    
    /** Remove trailing whitespace characters. */
    public String strip(String t) {
        while (t.length()>0) {
            char c = t.charAt(t.length()-1);
            if (c==' ' || c=='\t' || c=='\n' || c=='\r') {
                t = t.substring(0, t.length()-1);
            } else {
                return t;
            }
        }
        return t;
    }
 
    /** Get the class name of the program generator from the command line. */   
    public String getClassName(String className) {
        if (className.equals("")) {
            className = properties.getProperty("arg2");
            if (className.endsWith(".java")) {
                className = className.substring(0, className.length()-5);
                int j = className.lastIndexOf(File.separatorChar);
                if (j>=0) {
                    className = className.substring(j+1);
                }
            } else {
                // unknown class name, so just make one up
                className = "MyPG";
            }
        }
        return className;
    }


    /**
     * This method generates the output given a context and output stream
     */
    public boolean generate(XPathContext context, ProgramWriter out) {
        try {    out.print("\n/* Generated by ");
    out.print(version);
    out.print(" */\nimport org.w3c.dom.*;\nimport java.io.*;\nimport java.util.*;");
    NodeList x1 = context.evalNodeSet("//declare[@import]");
    for (int j1=0; j1<x1.getLength(); ++j1) {
        Node loopvar1 = (Node) x1.item(j1);
        context.push(loopvar1, j1+1, x1.getLength());
        out.print("\nimport ");
        out.print(context.evalString("./@import"));
        out.print(";");
        context.pop();
    }
    
    String className = getClassName(context.evalString("//declare/@classname"));
    String sclass = context.evalString("//declare/@extends");
    String classNameDef = className
    	+ (sclass.equals("") ? "" : (" extends "+sclass))
    	+ (context.evalBoolean("count(//declare[@implements])>0") ? " implements": "");
    
    out.print("\n\n/**\n * Program Generator created by TL2Java\n * @version ");
    out.print(new Date().toString());
    out.print("\n */\npublic class ");
    out.print(classNameDef);
    NodeList x2 = context.evalNodeSet("//declare[@implements]");
    for (int j2=0; j2<x2.getLength(); ++j2) {
        Node loopvar2 = (Node) x2.item(j2);
        context.push(loopvar2, j2+1, x2.getLength());
        out.print(" ");
        out.print(context.evalString("@implements"));
        if (context.evalBoolean("position()!=last()")) {
            out.print(",");
            
        }
        context.pop();
    }
    out.print(" {\n    Properties properties = new Properties();");
    NodeList x3 = context.evalNodeSet("//declarations");
    for (int j3=0; j3<x3.getLength(); ++j3) {
        Node loopvar3 = (Node) x3.item(j3);
        context.push(loopvar3, j3+1, x3.getLength());
        out.print("\n");
        out.print(context.evalString("."));
        context.pop();
    }
    out.print("\n\n    /**\n     * This method generates the output given a context and output stream\n     */\n    public boolean generate(XPathContext context, ProgramWriter out) {\n        try {");
    generate2(context, out); 
    out.print("\n        } catch (Exception e) {\n            System.out.println(\"Exception: \"+e.getMessage());\n            e.printStackTrace();\n            return false;\n        }\n        return true;\n    }\n    \n    /**\n     * A program generator is typically (but not always) invoked\n     * with a command line with arguments for the XML input file\n     * and output file.\n     */    \n    public static void main(String[] args) {\n        try {\n            ProgramWriter out = args.length>=2\n                ?new ProgramWriter(new FileOutputStream(args[1]))\n                :new ProgramWriter(System.out);\n            ");
    out.print(className);
    out.print(" pg = new ");
    out.print(className);
    out.print("();\n            for (int j=1; j<=args.length; ++j) {\n                pg.properties.put(\"arg\"+j, args[j-1]);\n            }\n            pg.generate(new XPathContext(args[0]), out);\n            out.close();\n        } catch (Exception e) {\n            e.printStackTrace();\n        }\n    }\n    \n    /**\n     * This array provides program generator development history\n     */\n    public String[][] history = {\n        { \"");
    out.print(new Date());
    out.print("\", // date this file was generated\n             ");
    out.print(quoteString(properties.getProperty("arg1")));
    out.print(", // input file\n             ");
    out.print(quoteString(properties.getProperty("arg2")));
    out.print(" }, // output file\n");
    
                for (int j=0; j<history.length; ++j) {
                    out.print("        {");
                    for (int k=0; k<history[j].length; ++k) {
                        out.print(quoteString(history[j][k])+", ");
                    }
                    out.println("}, ");
                }
    
    out.print("\n    };\n}");
    
        } catch (Exception e) {
            System.out.println("Exception: "+e.getMessage());
            e.printStackTrace();
            return false;
        }
        return true;
    }
    
    /**
     * A program generator is typically (but not always) invoked
     * with a command line with arguments for the XML input file
     * and output file.
     */    
    public static void main(String[] args) {
        try {
            ProgramWriter out = args.length>=2
                ?new ProgramWriter(new FileOutputStream(args[1]))
                :new ProgramWriter(System.out);
            TL2Java pg = new TL2Java();
            for (int j=1; j<=args.length; ++j) {
                pg.properties.put("arg"+j, args[j-1]);
            }
            pg.generate(new XPathContext(args[0]), out);
            out.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
    
    /**
     * This array provides program generator development history
     */
    public String[][] history = {
        { "Mon Apr 09 16:45:30 EDT 2001", // date this file was generated
             "TL2Java.xml", // input file
             "TL2Java.java" }, // output file
        {"Mon Apr 09 16:39:37 EDT 2001", "TL2Java.xml", "TL2Java.java", }, 
        {"Mon Apr 09 16:37:21 EDT 2001", "TL2Java.xml", "TL2Java.java", }, 
        {"Fri Feb 09 14:49:11 EST 2001", "TL2Java.xml", "TL2Java.java", }, 
        {"Fri Feb 09 14:30:24 EST 2001", "TL2Java.xml", "TL2Java.java", }, 
        {"Fri Feb 09 11:13:01 EST 2001", "TL2Java.xml", "TL2Java.java", }, 
        {"Fri Feb 09 10:57:04 EST 2001", "TL2Java.xml", "TL2Java.java", }, 
        {"Wed Apr 26 11:15:41 EDT 2000", "..\\input\\TL2Java.xml", "TL2Java1.java", }, 
        {"April 2000", "hand coded", "TL2Java1.java", }, 

    };
}